# SplatLLM

SplatLLM makes text generated by large language models (LLMs) appear more authentically human via heuristic-based formatting. Broadly, this involves:

* Removal of [invisible characters](https://invisible-characters.com/) that can be used for watermarking and/or hiding information in plain text.
* Remapping of unusual characters typically produced my LLMs but not typically used by human writers. For example, the Unicode dash punctuations commonly generated by LLMs are remapped to standard ASCII hyphens.
* Removal of certain markdown formatting characteristically used by LLMs.

SplatLLM can also be used to reveal invisible characters and other unusual formatting via the ``splat --show-invisibles`` / ``splat -s`` command:

![SplatLLM text analysis sample](https://raw.githubusercontent.com/theobjectivedad/splat-llm/refs/heads/master/images/splat_llm_dump.webp)

*Coming soon will be an MCP version that will expose SplatLLM as a callable tool for agent-driven post-formatting.*

## Quickstart

Install/run via ``uvx``:

```shell
uvx splatllm
```

Or, install via pip:

```shell
pip install SplatLLM
```

Then run:

```shell
splatllm
```

## Development Setup

First, clone this repository:

```shell
git clone https://github.com/theobjectivedad/splat-llm.git
```

Change directory to the cloned repository:

```shell
cd splat-llm
```

Next, setup your local virtual environment. Note that [uv](https://github.com/astral-sh/uv) will be installed if it isn't found in the environment:

```shell
make venv
```
